import fond.io.*;

public class ProvaTabellaDistanze{

	public static void main(String[] args){
		InputWindow in=new InputWindow();
		OutputWindow out=new OutputWindow();

		int dim=in.readInt("Numero di citt?");
		String[] citta=new String[dim];
		for(int i=0;i<dim;i++){
			String nome=in.readString("Nome della citt numero "+i+"?");
			citta[i]=nome;
		}
		int[][] distanze=new int[dim][dim];
		for(int i=0;i<dim;i++){
			for(int j=0;j<=i;j++){
				if(i==j)
					distanze[i][j]=0;
				else{
					int d=in.readInt("Distanza tra "+citta[i]+" e "+citta[j]+"?");
					distanze[i][j]=d;
					distanze[j][i]=d;
				}
			}
		}
		TabellaDistanze t=new TabellaDistanze(citta,distanze);
		out.writeln("La tabella creata :");
		out.writeln(t.toString());

		String[] lontane=t.cittaPiuDistanti();
		out.writeln("Le citt pi lontane sono "+lontane[0]+" e "+lontane[1]);

		String opzione=in.readString("Vuoi cercare le citt che distano pi di un certo valore da una citt di riferimento? (S/N)");

		while(!opzione.equals("N")){
			if(opzione.equals("S")){
				int k=in.readInt("Distanza da cercare?");
				String c=in.readString("Citt di riferimento?");
				String[] piuDistanti=t.cittaPiuDistantiDi(c,k);
				if(piuDistanti==null){
					out.write("La citt "+c+" non esiste");
				}else{
					out.write("Le citt pi distanti di "+k+" km da "+c+" sono:");
					for(int i=0;i<piuDistanti.length;i++)
						out.writeln(piuDistanti[i]);
				}
			}else{
				out.writeln("Opzione non valida");
			}
			opzione=in.readString("Vuoi cercare le citt che distano pi di un certo valore da una citt di riferimento? (S/N)");
		}
	}
}