public class SequenzaDiStringhe{
	private String[] seq;

	public SequenzaDiStringhe(String[] seq){
		this.seq=new String[seq.length];
		for(int i=0; i<seq.length; i++){
			this.seq[i]=seq[i];
		}
	}

	public int distanzaDiHamming(int i, int j){
		int ham;
		if(seq[i].length()!= seq[j].length())
			ham=-1;
		else{
			ham=0;
			for(int k=0; k<seq[i].length(); k++){
				if(seq[i].charAt(k)!=seq[j].charAt(k))
					ham++;
			}
		}
		return ham;
	}

	public double distanzaDiHammingMedia(){
		double somma=0;
		int count=0;
		for(int i=0; i<this.seq.length; i++){
			for(int j=i+1; j<this.seq.length; j++){
				int d=this.distanzaDiHamming(i,j);
				if(d!=-1){ // avevo detto che poteva essere omesso
					somma+=d;
					count++;
				}
			}
		}
		return somma/count;
	}

	public String toString(){
		String s="";
		for(int i=0; i<this.seq.length; i++){
			s+=this.seq[i]+"\n";
		}
		return s;
	}
}


