public class TabellaDistanze{
	private String[] citta;
	private int[][]distanze;

	public TabellaDistanze(String[] c, int[][]d){
		citta=new String[c.length];
		for(int i=0;i<citta.length;i++)
			citta[i]=c[i];
		distanze=new int[d.length][d[0].length];
		for(int i=0;i<distanze.length;i++){
			for(int j=0;j<distanze[0].length;j++)
				distanze[i][j]=d[i][j];
		}
	}

	public String[] cittaPiuDistanti(){
		String[] lontane=new String[2];
		int maxDist=0;
		int ind1=0;
		int ind2=0;
		for(int i=0;i<this.distanze.length;i++){
			for(int j=0;j<this.distanze[0].length;j++){
				if(this.distanze[i][j]>maxDist){
					maxDist=this.distanze[i][j];
					ind1=i;
					ind2=j;
				}
			}
		}
		lontane[0]=this.citta[ind1];
		lontane[1]=this.citta[ind2];
		return lontane;
	}

	public String[] cittaPiuDistantiDi(String c,int k){
		String[] lontane;

		int ind=-1;
		int i=0;
		while(i<this.citta.length && ind==-1){
			if(this.citta[i].equals(c))
				ind=i;
			i++;
		}

		if(ind==-1){
			lontane=null;
		}else{
			String[] tmp=new String[citta.length];
			int count=0;
			for(int j=0;j<this.distanze.length;j++){
				if(this.distanze[ind][j]>k){
					tmp[count]=citta[j];
					count++;
				}
			}
			lontane=new String[count];
			for(i=0;i<count;i++)
				lontane[i]=tmp[i];
		}
		return lontane;
	}

	public String toString(){
		String s="\t";
		for(int k=0;k<this.citta.length;k++){
			s+=citta[k]+"\t";
		}
		s+="\n";
		for(int i=0;i<this.citta.length;i++){
			s+=citta[i]+"\t";
			for(int j=0;j<this.distanze.length;j++){
				s+=distanze[i][j]+"\t";
			}
			s+="\n";
		}
		return s;
	}
}